/**
 * @summary     TableCalc
 * @description Calculate in HTML tables
 * @version     2.0.9
 * @file        jquery.tablecalc.min.js
 * @author      Tommy Hansen
 * @copyright   Consortia AS, Copyright 2018-2021.
 * @license     When used with Bulk Table Editor (license) no other license is needed
 */
!function($,window){"use strict";var calcRow={},settings={},licM="<h2>PS! Your license is not valid or has expired, please renew!</h2>",liv=!1,methods={init:function(l){return l=$.extend({},$.fn.tableCalc.defaults,l),(settings=l).filterRows={},this.each(function(){var e=$(this);settings.data||(settings.data=e.data(e[0].nodeName,e[0].id),setEvent.call(this,l),settings.calcOnLoad&&calculate(settings.calcType,settings.calcCustom,settings))})},destroy:function(){return $(window).off(".tableCalc"),this.each(function(){var e=$(this);e.data("tableCalc");e.removeData("tableCalc")})},getCurrentRow:function(){return calcRow.obj?calcRow.obj:0},calculate:function(e,l){return settings.data=this,calculate(e,l,settings)},getAllRows:function(){return settings.data=this,getAllRows(settings)},getSum:function(e){return liv?(settings.data=this,getSum(settings,e)):0},getAverage:function(e){return liv?(settings.data=this,getAverage(settings,e)):0},getMin:function(e){return liv?(settings.data=this,getMin(settings,e)):0},getMax:function(e){return liv?(settings.data=this,getMax(settings,e)):0},sortColumn:function(e,l){return liv?(settings.data=this,sortColumn(settings,e,l)):0}};function getMin(e,l){var t=getSumArray(e,l);return Number(t.reduce(function(e,l){return Math.min(e,l)}))}function getMax(e,l){var t=getSumArray(e,l);return Number(t.reduce(function(e,l){return Math.max(e,l)}))}function getSum(e,l){for(var t=getSumArray(e,l),a=0,n=0;n<t.length;n++)0<t[n].length&&(a+=parseFloat(t[n]));return a.toFixed(e.decimals)}function getAverage(e,l){for(var t=getSumArray(e,l),a=0,n=0,c=0,r=0;r<t.length;r++)0<t[r].length&&(a+=parseFloat(t[r]),c++);return 0<a&&(n=a/c),n.toFixed(e.decimals)}function getAllRows(e){var l=e.data,t={},a=[];try{t=l[0].children[1].rows}catch(e){console.log("No rows found: "+e.message)}for(var n=0;n<t.length;n++){var c=t[n];if(0<e.textColumns.length)for(var r=0;r<e.textColumns.length;r++){var s=c.cells[e.textColumns[r]].children[0].type;"SELECT"===c.cells[e.textColumns[r]].children[0].nodeName&&(s="select");var o="",i=c.cells[e.textColumns[r]].children.length;switch(s){case"date":case"datetime":case"text":o=c.cells[e.textColumns[r]].children[0].value;break;case"checkbox":o=c.cells[e.textColumns[r]].children[0].checked;break;case"radio":for(n=0;n<i;n++)if("INPUT"===c.cells[e.textColumns[r]].children[n].nodeName&&c.cells[e.textColumns[r]].children[n].checked){o=c.cells[e.textColumns[r]].children[n].id;break}break;case"select":i=c.cells[e.textColumns[r]].children[0].children.length;for(n=0;n<i;n++)if(c.cells[e.textColumns[r]].children[0].children[n].selected){o=c.cells[e.textColumns[r]].children[0].children[n].value;break}break;default:try{o=c.cells[e.textColumns[r]].children[0].value}catch(e){o="Input type not supported "}}a.push(JSON.stringify({id:t[n].children[e.rowId].id,column:t[n].children[e.textColumns[r]].cellIndex,value:o}))}if(0<e.calcColumns.length)for(r=0;r<e.calcColumns.length;r++)a.push(JSON.stringify({id:t[n].children[e.rowId].id,column:t[n].children[e.calcColumns[r]].cellIndex,value:t[n].children[e.calcColumns[r]].children[0].value}));null!==e.calcColumn_sum&&a.push(JSON.stringify({id:t[n].children[e.rowId].id,column:t[n].children[e.calcColumn_sum].cellIndex,value:t[n].children[e.calcColumn_sum].children[0].value}))}return a}function getSumArray(e,l){if(null!==e.calcColumn_sum){var t=e.data,a={},n=[];try{a=t[0].children[1].rows}catch(e){console.log("No rows found: "+e.message)}for(var c=0;c<a.length;c++)null==l?n.push(a[c].children[e.calcColumn_sum].children[0].value.replace(",",".")):n.push(a[c].children[l].children[0].value.replace(",","."));return n}}function calculate(e,l,t){if(0<e.length){"c"==(t.calcType=e).toLowerCase()&&0<l.length&&(t.calcCustom=l);var a="",n=t.calcCustom.split("==");if(1<n.length){t.calcCustom=n[0],a=n[1].split(":")[1].trim();for(var c,r=/0:[0-9]*/g,s=[];c=r.exec(t.calcCustom);)s.push(c[0].split(":")[1]);calcSpecial(t,s,a)}else calcOnLoad(t)}}function setEvent(h){var m=h.data;if(!liv){if(!valLic(h.license))return m[0].textContent=licM,0;liv=!0}$("#"+m[0].id+" input").on(h.onEvent,function(e){var l=$(this);if(l.closest("td").index()===h.calcColumn_sum)return 0;var t=$(this).closest("tr")[0].sectionRowIndex,a=m[0].children[1].rows[t];calcRow.obj=[];var n=0;null!==h.rowId&&(n=l.closest("tr").find("td:eq("+h.rowId+")").text());try{if(0<h.textColumns.length)for(var c=0;c<h.textColumns.length;c++){var r=a.cells[h.textColumns[c]].children[0].type;"SELECT"===a.cells[h.textColumns[c]].children[0].nodeName&&(r="select");var s="",o=a.cells[h.textColumns[c]].children.length;switch(r){case"date":case"datetime":case"text":s=a.cells[h.textColumns[c]].children[0].value;break;case"checkbox":s=a.cells[h.textColumns[c]].children[0].checked;break;case"radio":for(var i=0;i<o;i++)if("INPUT"===a.cells[h.textColumns[c]].children[i].nodeName&&a.cells[h.textColumns[c]].children[i].checked){s=a.cells[h.textColumns[c]].children[i].id;break}break;case"select":o=a.cells[h.textColumns[c]].children[0].children.length;for(i=0;i<o;i++)if(a.cells[h.textColumns[c]].children[0].children[i].selected){s=a.cells[h.textColumns[c]].children[0].children[i].value;break}break;default:try{s=a.cells[h.textColumns[c]].children[0].value}catch(e){s="Input type not supported"}}calcRow.obj.push(JSON.stringify({id:n,column:h.textColumns[c],value:s}))}}catch(e){console.log("Get textcolumn value fails: "+e.message)}try{if(0<h.calcColumns.length){var u=[];for(i=0;i<h.calcColumns.length;i++)if(this.parentElement.cellIndex===h.calcColumns[i]){s=parseFloat(this.value.toString().replace(",","."));u.push(JSON.stringify({id:i,value:s})),calcRow.obj.push(JSON.stringify({id:n,column:h.calcColumns[i],value:s}))}else{s=parseFloat(a.cells[h.calcColumns[i]].children[0].value.toString().replace(",","."));u.push(JSON.stringify({id:i,value:s})),calcRow.obj.push(JSON.stringify({id:n,column:h.calcColumns[i],value:s}))}var d=parseFloat(getCalculateResult(h,u)).toFixed(h.decimals);calcRow.obj.push(JSON.stringify({id:n,column:h.calcColumn_sum,value:d})),l.closest("tr").find("td:eq("+h.calcColumn_sum+") input").val(d)}}catch(e){console.log("Get numbercolumn value fails: "+e.message)}})}function calcOnLoad(e){var l=e.data,t={};if(!liv){if(!valLic(e.license))return void(l[0].textContent=licM);liv=!0}try{t=l[0].children[1].rows}catch(e){console.log("No rows found: "+e.message)}for(var a=0;a<t.length;a++)for(var n=t[a].cells,c=[],r=0;r<n.length;r++){var s=n[r];if("TD"===s.nodeName){var o=0;if(0<e.calcColumns.length)for(var i=0;i<e.calcColumns.length;i++)if(e.calcColumns[i]===s.cellIndex){var u=s.children[0];try{"INPUT"===u.nodeName&&c.push(JSON.stringify({id:i,value:u.value}))}catch(e){console.log("Info: "+e.message+", happens if row is missing input fields for calculation")}}if(e.calcColumns.length===c.length){o=getCalculateResult(e,c);try{o=parseFloat(o).toFixed(e.decimals)}catch(e){console.log("Result: "+e.message)}}if(s.cellIndex===e.calcColumn_sum&&(s.children[0].value=o,e.calcColumns.length===c.length)){c=[];continue}}}}function calcSpecial(e,l,t){var a=e.data,n={};try{n=a[0].children[1].rows}catch(e){console.log("No rows found: "+e.message)}for(var c=[],r=0;r<n.length;r++){for(var s=n[r].cells,o=0;o<l.length;o++)for(var i=0;i<s.length;i++)s[i].cellIndex===e.calcColumns[l[o]]&&c.push(JSON.stringify({id:l[o],value:s[i].children[0].value}));if(c.length===l.length){var u=getCalculateResult(e,c);u=parseFloat(u).toFixed(e.decimals),s[t].children[0].value=u,c=[]}}}function getCalculateResult(options,params){try{var retVal=0;if(0===params.length)return 0;var i=0;switch(options.calcType.toLowerCase()){case"a":for(i=0;i<params.length;i++){var j=JSON.parse(params[i]);0===i?retVal=Number(j.value):retVal+=Number(j.value)}return retVal;case"s":for(i=0;i<params.length;i++){var j=JSON.parse(params[i]);0===i?retVal=Number(j.value):retVal-=Number(j.value)}return retVal;case"m":for(i=0;i<params.length;i++){var j=JSON.parse(params[i]);0===i?retVal=Number(j.value):retVal*=Number(j.value)}return retVal;case"d":var strCalc="";for(i=0;i<params.length;i++){var j=JSON.parse(params[i]);strCalc+=j.value.toString()+"/ "}return strCalc=strCalc.slice(0,strCalc.length-2),eval(strCalc);case"c":var custom=options.calcCustom,expression=/0:[0-9]*/;for(i=0;i<params.length;i++){var j=JSON.parse(params[i]),str=new RegExp("0:"+j.id,"g");expression.test(custom)&&(0==j.value.length&&(j.value=0),custom=custom.replace(str,j.value))}return retVal=eval(custom),retVal;default:return 0}}catch(e){console.log("Calculation fails:"+e.message),$.error("Calculation fails:"+e.message)}return 0}function valLic(e){return"wbte-products"===gsp("page")}function sortColumn(e,l,t){var a=e.data,n={};try{n=a[0].children[1].rows}catch(e){return console.log("No rows found: "+e.message),0}for(var c,r,s=!0,o=0,i="asc";s;){for(s=!1,r=0;r<n.length-1;r++){c=!1;var u=n[r].cells[l],d=n[r+1].cells[l],h=!1;if(0<u.children.length)"input"==u.children[0].nodeName.toLowerCase()&&(h=!0,"number"===t&&(u=""==u.childNodes[1].value?0:parseFloat(u.childNodes[1].value.replace(/[^0-9.-]/g,"")),d=""==d.childNodes[1].value?0:parseFloat(d.childNodes[1].value.replace(/[^0-9.-]/g,""))),"text"===t&&(u=u.childNodes[1].value.replace(/^\s+|\s+$/g,""),d=d.childNodes[1].value.replace(/^\s+|\s+$/g,"")),"date"===t&&(u=""==u.childNodes[1].value?new Date(-2592e7):new Date(u.childNodes[1].value),d=""==d.childNodes[1].value?new Date(-2592e7):new Date(d.childNodes[1].value)),"percent"===t&&(u=""==u.childNodes[0].value?0:parseFloat(u.childNodes[0].value.replace(/%\s/g,"")),d=""==d.childNodes[0].value?0:parseFloat(d.childNodes[0].value.replace(/%\s/g,""))));if(h||("number"===t&&(u=u.innerText.replace(/[^0-9.-]/g,""),d=d.innerText.replace(/[^0-9.-]/g,"")),"text"===t&&(u=u.innerText.replace(/^\s+|\s+$/g,""),d=d.innerText.replace(/^\s+|\s+$/g,"")),"date"===t&&(u=""==u.innerText?new Date(-2592e7):new Date(u.innerText),d=""==d.innerText?new Date(-2592e7):new Date(d.innerText)),"percent"===t&&(u=u.innerText.replace(/%\s/g,""),d=d.innerText.replace(/%\s/g,""))),u!==d)if("asc"===i){if(d<u){c=!0;break}}else if("desc"===i&&u<d){c=!0;break}}c?(n[r].parentNode.insertBefore(n[r+1],n[r]),s=!0,o++):0==o&&"asc"==i&&(i="desc",s=!0)}}function gsp(e){var a={};return location.search.replace(/[?&]+([^=&]+)=([^&]*)/gi,function(e,l,t){a[l]=t}),e?a[e]:a}$.fn.tableCalc=function(e){return methods[e]?methods[e].apply(this,Array.prototype.slice.call(arguments,1)):"object"!=typeof e&&e?void $.error("Method "+e+" does not exist in plugin"):methods.init.apply(this,arguments)},$.fn.tableCalc.defaults={onEvent:"change",calcType:"m",calcColumns:[],calcColumn_sum:null,rowId:null,textColumns:[],calcCustom:"",decimals:2,calcOnLoad:!0,getMin:$.noop,getMax:$.noop,getSum:$.noop,getAverage:$.noop,getCurrentRow:$.noop,getAllRows:$.noop,calculate:$.noop,sortColumn:$.noop,filterRows:$.noop,license:null}}(jQuery,window);